#include "reference.h"
#define NUM_LED 6  

int notes[] = {NOTE_C4, NOTE_D4, NOTE_E4, NOTE_F4, NOTE_G4, NOTE_A4};
int randomSequence[] = {0, 0, 0, 0, 0, 0};

int randomSequenceLength = 10;       //denotes the number of levels
int turn;
int level;
int started = 0;                 //denotes whether or not the game has started

int readings[6];
int biggestVal;
int pressedMuscleNumber;
int maxINPUT = 1000;
int musclePin[6] = {A0, A1, A2, A3, A4, A5};
int reading[10];    // Used later for reading the electrical signals in your arm. 
int finalReading;
byte litLeds = 0;
byte multiplier = 1;
byte leds[] = {8, 9, 10, 11, 12, 13};

int losingTone = 230;               //frequency that plays when you lose
int winningTone = 880;              //frequency that plays when you win

void setup() {
  Serial.begin(9600); 
  for(int i = 0; i < NUM_LED; i++){     //Sets the LEDs as outputs.
    pinMode(leds[i], OUTPUT);
  }
}

void loop() {
  if (started == 0){                                       //if the game hasn't started, set it up:
        for (int i = 0; i < randomSequenceLength; i++){      //set up the random sequence.
            randomSequence[i] = rand() % 5;
        }
        started = 1;                             //say the game has started
        turn = 0;                                   //set the turn to 0
        level = 1;                                  //set the level to 1
  }
    while (started == 1){                                        //while the game is running
        for (int i = 0; i < level; i++){                            //play the sequence with the leds
            tone(8, notes[randomSequence[i]]);              
            digitalWrite(leds[randomSequence[i]], HIGH);
            delay(500);
        }
        for (int turn = 0; turn < level; turn++){                 //for every turn on the level...
          for (int i = 0; i < 6; i++) {
                    //First finds the value for a specific channel and outputs that raw value to the monitor. 
                    //Then checks if that value is the largest so far.
            readings[i] = analogRead(musclePin[i]); 
            Serial.print("Channel ");
            Serial.print(readings[i]);                
            readings[i] = constrain(readings[i], 0, maxINPUT);
            readings[i] = map(readings[i], 0, maxINPUT, 0, 100);
                  
            if (biggestVal < readings[i]) {
            biggestVal = readings[i];
            pressedMuscleNumber = i;
                    }
                  }

                    if (randomSequence[turn] == pressedMuscleNumber){          //if it's the correct move, play the note,
                        tone(8, notes[pressedMuscleNumber]);                     // show the light, increment turn by one and break out of the loop
                        digitalWrite(leds[pressedMuscleNumber], HIGH);
                        delay(500);
                        turn++;
                        break;
                    }

                    else{                           //if it's not the correct move, turn on all the leds,
                        tone(8, losingTone);              //play a sound, set started to 0 and break out of the loop
                        for (int k = 0; k < 6; k++){
                            digitalWrite(leds[k], HIGH);
                        }
                        delay(1000);
                        started = 0;
                        break;
                    }
            }
        turn += 1;                                  //increment turn by one
    }
    if (turn == level){                             //if you finished the last turn of the level..
        if(level == randomSequenceLength){           //if you finished the last level, play a sound, turn on all the
            tone(8, winningTone);                      //leds and set started to 0
            for (int k = 0; k < 6; k++){
              digitalWrite(leds[k], HIGH);
            }
            delay(1000);
            started = 0;
        }
    }
        
        else{                                        //if you're not in the last level, increment the level by one
            turn = 0;                                //and set turn to 1
            level += 1;
        }
}
